#!/usr/bin/env python
# -*- coding: utf-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Serveur xmlrpc pour la compilation des paquets EoleNg
#
###########################################################################

from twisted.web import xmlrpc, server
import subprocess
import os

# FIXME : à deplacer ?
def make_cd(cdversion):
    """génération d'un cd EoleNg"""
    os.chdir("/home/eole/mirror/cdimage")
    retcode = subprocess.call("for-project %s cron.daily | tee -a rapport.txt"%cdversion, shell=True)
    if retcode != 0:
        return False, "Erreur lors de la compilation, consultez le rapport"
    return True, "Compilation réussie"

class ServerXMLRPC(xmlrpc.XMLRPC):

    def xmlrpc_make_cd(self, cdversion):
        """ serveur xmlrpc"""
        return make_cd(cdversion)

if __name__ == '__main__':
    from twisted.internet import reactor
    r = ServerXMLRPC()
    reactor.listenTCP(7081, server.Site(r))
    reactor.run()
