# -*- coding: utf-8 -*-
###########################################################################
#
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr
#
# librairie pour la suppression des paquets recompilés
#
###########################################################################
"""
Librairie pour la suppression des paquets
sur le répository
"""

from os.path import join
from eolepack import eolepackdb
from eolepack.config import EOLEPACK_FILE
from eolepack.cfgparser import Config
import os

def delete_package(paquet, version, dist_eole):
    """
    Suppresion des paquets recompilés
    """
    cfg = Config(EOLEPACK_FILE)
    ssh_account = cfg.get_main_value(dist_eole, 'DEPOT_SSH_ACCOUNT')
    pool_path = cfg.get_main_value(dist_eole, 'DEPOT_POOL_PATH')
    path = join(pool_path, dist_eole)
    files = join(path, "%s_%s*" % (paquet, version))
    binaires = eolepackdb.get_binaires(paquet)
    for bin in binaires:
        files += " %s" % join(path, "%s_%s*" % (bin, version))
    print """ssh %s "rm -rf %s" """ % (ssh_account, files)
    os.system("""ssh %s "rm -rf %s" """ % (ssh_account, files))
    return True, 'suppression OK'

