#!/usr/bin/env python
# -*- coding: utf-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Serveur xmlrpc pour la compilation des paquets EoleNg
#
###########################################################################

from twisted.web import xmlrpc, server
from eolepack.pack import pack

class ServerXMLRPC(xmlrpc.XMLRPC):

    def xmlrpc_pack(self, paquet, version, distribution, tags=None, branches=None, revision=None, epoch=None, changelog=None):
        # serialisation de la chaine None pour le xmlrpc
        for var in ['tags','branches','revision','epoch','changelog']:
            if eval(var) == 'None':
                exec(var+"=None")

        """Return all passed args."""
        return pack(paquet, version, distribution, tags, branches, revision, epoch, changelog)

if __name__ == '__main__':
    from twisted.internet import reactor
    r = ServerXMLRPC()
    reactor.listenTCP(7082, server.Site(r))
    reactor.run()
